import 'package:algolia/algolia.dart';

abstract class baseTRepo<T>{
  Future<List<T>>searchT_algo(String? qr,
      {List<String> attributes=const ["objectId"],
        List<AlgoliaQuery Function(AlgoliaQuery)>?filters ,List<String>? strFilters,
        int page=0,int hperp=10,String? containID});

  Future<AlgoliaQuerySnapshot>searchTSnaps_algo(String? qr,
      {List<String> attributes=const ["objectId"],
        List<AlgoliaQuery Function(AlgoliaQuery)>?filters ,List<String>? strFilters,
        int page=0,int hperp=10,String? containID});

  Future<List<T>> snaps_2_Tdata(List<AlgoliaObjectSnapshot> snaps);

  Future<T> getbyId(String id);
  Future<T> read(T c,String uid);
  Future<String> add(T c);
  Future<void> edit(T c);
  Future<void> deletebyId(String id);
}